//document always UTF-8
function meta(lang, os) {
	var meta = {};
	meta.enable = false;	//change this as true to enable
	meta.name = "Demo Alpha";	//always have 2 capital letters
	if (lang == "en-GB") {	//language example
//		meta.name = "Hello World";	//native language if u have
	}
	meta.provider = "Official";	//the author name, show on effects list
	meta.repeat = false;	//true for allow repeat
	meta.description = "change the transparency,\nmodify the transparency for specific area";
	meta.type = "image";	//image for ARGB
	
	if (os.indexOf("FreeBSD")>=0) {	//OS is FreeBSD
//		meta.repeat = true;
	}
	
	meta.options = [	//option values user select for main as parameter follow this order
		{	//at least one option for UI
			name: "alpha max",
			description: "the alpha max percent, from 0 to 100, \nskip if smaller than value",
			value: 40,	//must have an value
			min: 1,
			max: 100
		}
//		,{
//			name: "demo1",
//			description: "demo1 long tip",
//			value: 2
//		}
	];
	/*
	 * remember, don't leave key operation here,
	 * when user restart the application with incomplete job,
	 * the job state will save to disk, 
	 * next this result will read from it, so here may never call.
	 */
	return JSON.stringify(meta);	//do return as string
}

function image(milliseconds, argb, size, x, y, w, h, options) {	//by meta.type
	var a_max = 0xff * options[0] / 100;	//the 0xff with percent
	var a_max_24 = (a_max << 24);	//as first 8bit of 32bit, because AARRGGBB
	
//	if (options[0] == 13) throw "this's demo error";	//throw error, on encoder step as log
//	print("EV_ColorAlpha: " + a_max);	//debug output, if v2mixer run in terminal mode

	for (var yh=y +h, xw=x +w, x2,y2,a,b,c; y<yh; y++) {
		for (y2=y * size, x2=x; x2<xw; x2++) {
			c = y2 + x2;
			b = argb[c];	//argb always AARRGGBB,AARRGGBB..
			a = ((b & 0xff000000) >>> 24);	//only alpha
			
			if (a > a_max) {
				b = (b & 0x00ffffff);	//RGB without AA
				argb[c] = (a_max_24 | b);	//use a_max 
			}
		}
	}
	/*
	 * none return here, the argb is memory map, u already change above.
	 * so u must check all are ready before change.
	 */
}